; Xe[WP

EN_ST1_CHAPTER		.equ	0
EN_ST1_FAIRY_A		.equ	1
EN_ST1_FAIRY_B		.equ	2
EN_ST1_FAIRY_C		.equ	3
EN_ST1_FAIRY_D		.equ	4
EN_ST1_SHANGHI_A	.equ	5
EN_ST1_SHANGHI_B	.equ	6
EN_ST1_HOURAI_A		.equ	7
EN_ST1_ALICE_A		.equ	8
EN_ST1_ALICE_B		.equ	9
EN_ST1_ALICE_C		.equ	10
EN_ST1_ALICE_D		.equ	11
EN_ST1_ALICE_E		.equ	12
EN_ST1_ALICE_F		.equ	13
EN_ST1_ALICE_G		.equ	14

EN_ST1_CMD	.equ	(EVS_U)		;   2bytes EVS_U & EVS_V
EN_ST1_PHASE	.equ	(EVS_E)
EN_ST1_INX	.equ	(EN_WORK)	;   6bytes
EN_ST1_COUNT	.equ	(EN_WORK+6)	;   6bytes
EN_ST1_TRACK	.equ	(EN_WORK+12)	; 3*4bytes
EN_ST1_X	.equ	(EN_WORK+16)	;   6bytes
EN_ST1_Y	.equ	(EN_WORK+22)	;   6bytes
EN_ST1_U	.equ	(EN_WORK+32)	;   6bytes
EN_ST1_V	.equ	(EN_WORK+38)	;   6bytes
EN_ST1_DX	.equ	(EN_WORK+48)	;   6bytes
EN_ST1_DU	.equ	(EN_WORK+54)	;   6bytes
EN_ST1_DY	.equ	(EN_WORK+60)	;   6bytes
EN_ST1_DV	.equ	(EN_WORK+66)	;   6bytes
EN_ST1_A	.equ	(EN_WORK+72)	;   6bytes
EN_ST1_SP	.equ	(EN_WORK+78)	;   6bytes
EN_ST1_X2	.equ	(EN_WORK+84)	;   6bytes
EN_ST1_Y2	.equ	(EN_WORK+90)	;   6bytes

St1_Data:

; V[PX

St1_EventSeq:

	EV_BANK2	BANK_CHR_ENEMY
	EV_BANK3	BANK_CHR_CHAPT
	EV_BGM		2
	EV_SET		EVS_SPEED, BSW_8F_M
	EV_SET		EVS_F, 0
St1_EventSeqEndless:
	.if	0
	EV_WAIT		16
	EV_BGM		3
	EV_BANK3	BANK_CHR_BOSS
	EV_PAL		COL_ALICE
	EV_ENEMY	EN_ST1_ALICE_C, POS_2_8
	EV_WAIT_SEM
;	EV_SETUP	SSF_MODE_BOSS
;	EV_NEXT_STEP	0, EN_ST1_ALICE_D
;	EV_WAIT_SEM
;	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
;	EV_NEXT_STEP	0, EN_ST1_ALICE_E
;	EV_WAIT_SEM
;	EV_SETUP	SSF_MODE_BOSS|SSF_RESOLVE_BONUS
;	EV_NEXT_STEP	0, EN_ST1_ALICE_F
;	EV_WAIT_SEM
	EV_SET		EVS_F, 1
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST1_ALICE_G
	EV_WAIT_SEM
.head:
	EV_NATIVE	.tail
	ldx	#(BGS_CNT3-BGS_CNT3)
	jsr	BGSeq_ClearLayerCB
	ldx	#RLF_CLR_LAYER3
	jmp	BGSeq_ReqSetHighLayer
	ldy	#(.tail-.head)
	rts
.tail:
	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	.endif
;	EV_JMP		St1_EventSeqBoss1
;	EV_JMP		St1_EventSeqSecond
;	EV_JMP		St1_EventSeqTalk

;	EV_WAIT		16
;	EV_END

	EV_WAIT		10
	EV_ENEMY	EN_ST1_CHAPTER,0
	EV_WAIT		50

	EV_BANK3	BANK_CHR_BOSS
	EV_PAL		COL_FAIRY_BLUE
	EV_ENEMY	EN_ST1_FAIRY_A, POS_24_2+$e0
	EV_ENEMY	EN_ST1_FAIRY_A, POS_104_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_32_2+$c0
	EV_ENEMY	EN_ST1_FAIRY_A, POS_96_2+$d0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_48_2+$a0
	EV_ENEMY	EN_ST1_FAIRY_A, POS_80_2+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_16_2+$80
	EV_ENEMY	EN_ST1_FAIRY_A, POS_112_2+$90
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_40_2+$60
	EV_ENEMY	EN_ST1_FAIRY_A, POS_88_2+$70
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_56_2+$40
	EV_ENEMY	EN_ST1_FAIRY_A, POS_72_2+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_16_2+$20
	EV_ENEMY	EN_ST1_FAIRY_A, POS_112_2+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_32_2
	EV_ENEMY	EN_ST1_FAIRY_A, POS_96_2+$10
	EV_WAIT		20


	EV_ENEMY	EN_ST1_FAIRY_B, POS_16_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_32_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_48_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_112_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_96_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_80_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_56_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_40_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_24_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_72_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_88_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_104_2
	EV_WAIT		2

	EV_ENEMY	EN_ST1_FAIRY_A, POS_24_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_40_2+$e0
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_A, POS_104_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_88_2+$f0
	EV_WAIT		2

	EV_ENEMY	EN_ST1_FAIRY_C, POS_56_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_32_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_72_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_96_2
	EV_WAIT		2


	EV_ENEMY	EN_ST1_FAIRY_B, POS_64_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_48_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_40_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_96_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_80_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_104_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_32_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_48_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_56_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_16_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_112_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_88_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_32_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_80_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_8_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_96_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_16_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_72_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_48_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_112_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_24_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_96_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_32_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_120_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_64_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_80_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_40_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_96_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_48_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_104_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_16_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_64_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_72_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_112_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_32_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_8_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_80_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_64_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_120_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_96_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_32_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_56_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_16_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_112_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_24_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_B, POS_64_2
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_B, POS_48_2
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_88_2+$f0

	EV_WAIT		10

	EV_SET		EVS_C, 4
St1_EventSeqLoop1:
	EV_ENEMY	EN_ST1_FAIRY_A, POS_24_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_40_2+$d0
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_A, POS_32_2+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_48_2+$90
	EV_WAIT		6
	EV_ENEMY	EN_ST1_FAIRY_C, POS_80_2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_104_2
	EV_WAIT		6

	EV_ENEMY	EN_ST1_FAIRY_A, POS_104_2+$e0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_88_2+$c0
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_A, POS_96_2+$a0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_80_2+$80
	EV_WAIT		6
	EV_ENEMY	EN_ST1_FAIRY_C, POS_48_2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_24_2
	EV_WAIT		6

	EV_NATIVE	.tail
	dec	EVS_C
	bne	.1
	iny
	iny
.1:
	rts
.tail:
	EV_JMP		St1_EventSeqLoop1

	EV_ENEMY	EN_ST1_FAIRY_A, POS_24_2+$e0
	EV_ENEMY	EN_ST1_FAIRY_A, POS_104_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_32_2+$c0
	EV_ENEMY	EN_ST1_FAIRY_A, POS_96_2+$d0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_48_2+$a0
	EV_ENEMY	EN_ST1_FAIRY_A, POS_80_2+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_16_2+$80
	EV_ENEMY	EN_ST1_FAIRY_A, POS_112_2+$90
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_40_2+$60
	EV_ENEMY	EN_ST1_FAIRY_A, POS_88_2+$70
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_56_2+$40
	EV_ENEMY	EN_ST1_FAIRY_A, POS_72_2+$50
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_16_2+$20
	EV_ENEMY	EN_ST1_FAIRY_A, POS_112_2+$30
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_32_2
	EV_ENEMY	EN_ST1_FAIRY_A, POS_96_2+$10
	EV_WAIT		10

	EV_ENEMY	EN_ST1_FAIRY_C, POS_8_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_120_2+$20
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_40_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_88_2+$20
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_72_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_56_2+$20
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_104_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_24_2+$20
	EV_WAIT		36

St1_EventSeqBoss1:
	EV_BANK3	BANK_CHR_BOSS
	EV_PAL		COL_ALICE
;	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_SETUP	SSF_MODE_BOSS|SSF_RESOLVE_BONUS
	EV_ENEMY	EN_ST1_ALICE_A, POS_2_72
	EV_WAIT_SEM
.head:
	EV_NATIVE	.tail
	lda	EVS_SPELL
	cmp	#1
	bne	.2
	lda	#LOW(1000)
	ldy	#HIGH(1000)
	jsr	Util_AddCherry2
.2:
	ldy	#(.tail-.head)
	rts
.tail:

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST1_ALICE_B
	EV_WAIT		10

St1_EventSeqSecond:
	EV_PAL		COL_FAIRY_BLUE
	EV_SET		EVS_C, 8
	EV_SET		EVS_B, 0
St1_EventSeqLoop2:
	EV_ENEMY	EN_ST1_FAIRY_A, POS_24_2+$e0
	EV_ENEMY	EN_ST1_FAIRY_A, POS_104_2+$f0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_48_2+$c0
	EV_ENEMY	EN_ST1_FAIRY_A, POS_80_2+$d0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_16_2+$a0
	EV_ENEMY	EN_ST1_FAIRY_A, POS_112_2+$b0
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_40_2+$80
	EV_ENEMY	EN_ST1_FAIRY_A, POS_88_2+$90
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_56_2+$60
	EV_ENEMY	EN_ST1_FAIRY_A, POS_72_2+$70
	EV_WAIT		1
	EV_ENEMY	EN_ST1_FAIRY_A, POS_32_2+$40
	EV_ENEMY	EN_ST1_FAIRY_A, POS_96_2+$50
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_8_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_24_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_104_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_120_2+$20
.head:
	EV_NATIVE	.tail
	ldy	EVS_B
	lda	.offset,y
	iny
	cpy	#6
	bcc	.1
	ldy	#0
.1:
	sty	EVS_B
	tay
	rts
.offset:
	.db	(.enemy1 - .head)
	.db	(.enemy2 - .head)
	.db	(.enemy3 - .head)
	.db	(.enemy4 - .head)
	.db	(.enemy5 - .head)
	.db	(.enemy6 - .head)
.tail:
.enemy1:
	EV_ENEMY	EN_ST1_FAIRY_D, POS_126_56
	EV_JMP		.next1
.enemy2:
	EV_ENEMY	EN_ST1_FAIRY_D, POS_2_48+$80
	EV_JMP		.next1
.enemy3:
	EV_ENEMY	EN_ST1_FAIRY_D, POS_126_40
	EV_JMP		.next1
.enemy4:
	EV_ENEMY	EN_ST1_FAIRY_D, POS_2_56+$80
	EV_JMP		.next1
.enemy5:
	EV_ENEMY	EN_ST1_FAIRY_D, POS_126_48
	EV_JMP		.next1
.enemy6:
	EV_ENEMY	EN_ST1_FAIRY_D, POS_2_40+$80
.next1:
	EV_WAIT		13

St1_EventSeqSkip2:
	EV_NATIVE	.tail
	lda	<ST_CNT+1
	cmp	#$02
	bne	.1
	lda	<ST_CNT
	cmp	#$c0
.1:
	bcc	.2
	iny
	iny
.2:
	rts
.tail:
	EV_JMP		St1_EventSeqLoop2
	EV_WAIT		12

	EV_ENEMY	EN_ST1_FAIRY_D, POS_2_64+$80
	EV_WAIT		6
	EV_ENEMY	EN_ST1_FAIRY_D, POS_126_56
	EV_WAIT		6
	EV_ENEMY	EN_ST1_FAIRY_D, POS_2_48+$80
	EV_WAIT		6
	EV_ENEMY	EN_ST1_FAIRY_D, POS_126_40
	EV_WAIT		10
	EV_ENEMY	EN_ST1_FAIRY_C, POS_8_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_40_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_72_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_104_2+$20
	EV_WAIT		2
	EV_ENEMY	EN_ST1_FAIRY_C, POS_24_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_56_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_88_2+$20
	EV_ENEMY	EN_ST1_FAIRY_C, POS_120_2+$20
	EV_WAIT		30

St1_EventSeqTalk:
	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		16

	EV_TALK		1
	EV_PAL		COL_ALICE
	EV_ENEMY	EN_ST1_ALICE_C, POS_2_8
	EV_WAIT_SEM

	EV_TALK		2
	EV_PAL		COL_ALICE

	EV_SETUP	SSF_MODE_BOSS
	EV_NEXT_STEP	0, EN_ST1_ALICE_D
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST1_ALICE_E
	EV_WAIT_SEM

	EV_SETUP	SSF_MODE_BOSS|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST1_ALICE_F
	EV_WAIT_SEM

	EV_SET		EVS_F, 1
	EV_SETUP	SSF_MODE_BOSS|SSF_BG_EFFECT|SSF_RESOLVE_BONUS
	EV_NEXT_STEP	0, EN_ST1_ALICE_G
	EV_WAIT_SEM
.head:
	EV_NATIVE	.tail
	ldx	#(BGS_CNT3-BGS_CNT3)
	jsr	BGSeq_ClearLayerCB
	ldx	#RLF_CLR_LAYER3
	jmp	BGSeq_ReqSetHighLayer
	ldy	#(.tail-.head)
	rts
.tail:

	EV_SETUP	SSF_MODE_NORMAL|SSF_RESOLVE_BONUS
	EV_WAIT		8
	EV_SETUP	SSF_CONVERGE_BORDER
	EV_TALK		3
	EV_PAL		COL_ALICE
	EV_END

;	EV_WAIT		64
;	EV_SET		EVS_SPEED, BSW_32F_M
;	EV_WAIT		1
;	EV_JMP		St1_EventSeqEndless

; G֌W

Enemy_Alice_Reflect:
	ldx	<EN_BOSS_INX
	bmi	.vanish2

	lda	EN_LIFE,x
	eor	#$80
	sec
	adc	<EN_BOSS_LIFE_L
	sta	<EN_BOSS_LIFE_L
	lda	<EN_BOSS_LIFE_H
	adc	#$ff
	bmi	.vanish1
	sta	<EN_BOSS_LIFE_H
	ora	<EN_BOSS_LIFE_L
	beq	.vanish1
	lda	#$7f
	sta	EN_LIFE,x

	lda	<EN_BOSS_LIFE_L
	lsr	a
	sta	<EN_LIFE_INX

	lda	<DSP_FLAG
	ora	#DSF_POS
	sta	<DSP_FLAG

	rts

.vanish1:
	lda	EVS_SEM
	beq	.vanish3
	lda	EN_S,x
	dec	EVS_SPELL
	bne	.vanish4
	ora	#$80
	sta	EN_S,x
	lda	#0
	sta	EN_LIFE,x
.vanish2:
	lda	#0
	sta	<EN_LIFE_INX
	sta	EN_FNC_REFLECT
	sta	EN_FNC_REFLECT+1
	sta	EVS_SEM
.vanish3:
	rts
.vanish4:
	ora	#$40
	sta	EN_S,x

	lda	#SE_EN_OUT2
	cmp	<SND_SE
	bcc	.vanish5
	sta	<SND_SE
.vanish5:

	lda	#0
	sta	EVS_SEM
	jmp	Enemy_Boss_Retire

; `F[֐

St1_EnChapter:
	lda	#40
	sta	EN_X,x
	lda	#64
	sta	EN_Y,x
	lda	#$40
	jmp	Enemy_Effect_Create

St1_EnFairyA:
	sta	<FNC_WORK+6
	and	#$0f
	tay
	jsr	Enemy_SetPosition

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	ldy	<FNC_WORK+6
	lda	Xcn,y
	sta	EN_D,x
	and	#$0e
	clc
	adc	#32
	jsr	Enemy_CB_Wait

	lda	EN_D,x
	and	#$01
	tay
	lda	EN_S,x
	ora	.direct,y
	sta	EN_S,x

	jsr	Rand
	and	#$06
	ora	Int,y
	tay
	lda	.angle,y
	tay
	lda	#12
	jsr	Enemy_SetVelocity
	jmp	Enemy_ClearAcceleration
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$01,$03,$02,$00	; T,S,LIFE,P
	.db	$80,14		; A,SP
	.db	$0a,$fe,$00	; VC,IS,IA
.direct:
	.db	$08,$04
.angle:
	.db	$74,$8c,$68,$98,$5c,$a4,$50,$b0

St1_EnFairyB:
	tay
	jsr	Enemy_SetPosition

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	PLC_COL2PAL+COL_YELLOW
	sta	EN_S,x
	rts
.param:
	.db	EPF_BASE|EPF_VEL
	.db	$01,$03,$02,$00	; T,S,LIFE,P
	.db	$80,8		; A,SP

St1_EnFairyC:
	sta	<FNC_WORK+6
	and	#$0f
	tay
	jsr	Enemy_SetPosition

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam
	lda	PLC_COL2PAL+COL_YELLOW
	sta	EN_S,x

	ldy	<FNC_WORK+6
	lda	Xcn,y
	and	#$0f
	sta	EN_D,x

	lda	#32
	jsr	Enemy_CB_Wait

	lda	EN_D,x
	bne	.1
	jsr	Rand
	and	#$07
	cmp	#$02
	bcs	.2
.1:
	tay
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)
.2:

	ldy	#0
	lda	#14
	jsr	Enemy_SetVelocity
	jmp	Enemy_ClearAcceleration
.param:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$01,$03,$02,$00	; T,S,LIFE,P
	.db	$80,26		; A,SP
	.db	$02,$fe,$00	; VC,IS,IA
.blt_lo:
	.db	LOW(BL(0,Blt1_FairyC1))
	.db	LOW(BL(0,Blt1_FairyC2))
	.db	LOW(BL(0,Blt1_FairyC3))
.blt_hi:
	.db	HIGH(BL(0,Blt1_FairyC1))
	.db	HIGH(BL(0,Blt1_FairyC2))
	.db	HIGH(BL(0,Blt1_FairyC3))

St1_EnFairyD:
	sta	EN_D,x
	and	#$3f
	tay
	jsr	Enemy_SetPosition

	lda	EN_D,x
	bmi	.1
	lda	#LOW(.param1)
	ldy	#HIGH(.param1)
	bne	.2	; same as jmp
.1:
	lda	#LOW(.param2)
	ldy	#HIGH(.param2)
.2:
	jsr	Enemy_SetParam

	lda	#40
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	and	#$f3
	sta	EN_S,x
	lda	#$00
	sta	EN_SP,x
	sta	EN_DX,x
	sta	EN_DY,x
	sta	EN_DU,x
	sta	EN_DV,x
	jsr	Enemy_ClearAcceleration

	lda	#10
	jsr	Enemy_CB_Wait

	jsr	Rand
	lsr	a
	and	#$07
	tay
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	#20
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	and	#$30
	lsr	a
	lsr	a
	ora	EN_S,x
	sta	EN_S,x
	lda	EN_A,x
	eor	#$80
	sta	EN_A,x
	tay
	lda	#14
	jsr	Enemy_SetVelocity
	jsr	Enemy_ClearAcceleration

	rts
.param1:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$02,$1b,$08,(ITEM_L_POWER<<4)+3	; T,S,LIFE,P
	.db	$40,34		; A,SP
	.db	$02,$fe,$00	; VC,IS,IA
.param2:
	.db	EPF_BASE|EPF_VEL|EPF_ACC
	.db	$02,$27,$08,(ITEM_L_POWER<<4)+3	; T,S,LIFE,P
	.db	$c0,34		; A,SP
	.db	$02,$fe,$00	; VC,IS,IA
.blt_lo:
	.db	LOW(BL(0,Blt1_FairyD1))
	.db	LOW(BL(0,Blt1_FairyD2))
	.db	LOW(BL(0,Blt1_FairyD3))
	.db	LOW(BL(0,Blt1_FairyD4))
	.db	LOW(BL(0,Blt1_FairyD1))
	.db	LOW(BL(0,Blt1_FairyD3))
	.db	LOW(BL(0,Blt1_FairyD4))
	.db	LOW(BL(0,Blt1_FairyD4))
.blt_hi:
	.db	HIGH(BL(0,Blt1_FairyD1))
	.db	HIGH(BL(0,Blt1_FairyD2))
	.db	HIGH(BL(0,Blt1_FairyD3))
	.db	HIGH(BL(0,Blt1_FairyD4))
	.db	HIGH(BL(0,Blt1_FairyD1))
	.db	HIGH(BL(0,Blt1_FairyD3))
	.db	HIGH(BL(0,Blt1_FairyD4))
	.db	HIGH(BL(0,Blt1_FairyD4))

St1_EnAliceA:
	tay
	jsr	Enemy_SetPosition

	lda	#1
	sta	EVS_SEM

	lda	#2
	sta	EVS_SPELL

	; o

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#3
	sta	EVS_A

	lda	#23
	sta	<EN_TIME

.loop1:
	lda	#$ff
	sta	EVS_B
	; ړ

	lda	#LOW(.retry1)
	sta	EN_CB,x
	lda	#HIGH(.retry1)
	sta	EN_CB+1,x
.retry1:
	lda	#64
	ldy	#48
	jsr	Enemy_CB_Move

	; e
	inc	EVS_B
	ldy	EVS_B
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	EN_S,x
	and	#$c1
	ora	#$02
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	eor	#$06
	sta	EN_S,x

	lda	#44
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	and	#$c1
	sta	EN_S,x

	lda	#12
	jsr	Enemy_CB_Wait

	; e
	inc	EVS_B
	ldy	EVS_B
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	EN_S,x
	and	#$c1
	ora	#$02
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	eor	#$06
	sta	EN_S,x

	lda	#32
	jsr	Enemy_CB_Wait

	; ړ
	jsr	St1_EnAlice_SelectPos
	lda	#LOW(.retry4)
	sta	EN_CB,x
	lda	#HIGH(.retry4)
	sta	EN_CB+1,x
.retry4:
	lda	EVS_X
	ldy	EVS_Y
	jsr	Enemy_CB_Move

	; e
	inc	EVS_B
	ldy	EVS_B
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	EN_S,x
	and	#$c1
	sta	EN_S,x

	lda	EN_S,x
	and	#$c1
	ora	#$02
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	eor	#$06
	sta	EN_S,x

	lda	#32
	jsr	Enemy_CB_Wait

	; ړ
	jsr	St1_EnAlice_SelectPos
	lda	#LOW(.retry6)
	sta	EN_CB,x
	lda	#HIGH(.retry6)
	sta	EN_CB+1,x
.retry6:
	lda	EVS_X
	ldy	EVS_Y
	jsr	Enemy_CB_Move

	; e
	inc	EVS_B
	ldy	EVS_B
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	EN_S,x
	and	#$c1
	ora	#$02
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	eor	#$06
	sta	EN_S,x

	lda	#44
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	and	#$c1
	sta	EN_S,x

	lda	#12
	jsr	Enemy_CB_Wait

	; ^CAbv{[v
	dec	EVS_A
	beq	.next10
	jmp	.loop1
.next10:
	; 
	lda	#1
	sta	EVS_SPELL

	lda	#0
	sta	<EN_BOSS_LIFE_L
	sta	<EN_BOSS_LIFE_H
	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS|EPF_REFLECT
	.db	$45,$0a,$7f,(ITEM_BOMB<<4)+7	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$0080		; BOSS_LIFE
	.dw	Enemy_Alice_Reflect
.blt_lo:
	.db	LOW(BL(0,Blt1_AliceA1))
	.db	LOW(BL(0,Blt1_AliceA2))
	.db	LOW(BL(0,Blt1_AliceA1))
	.db	LOW(BL(0,Blt1_AliceA2))
.blt_hi:
	.db	HIGH(BL(0,Blt1_AliceA1))
	.db	HIGH(BL(0,Blt1_AliceA2))
	.db	HIGH(BL(0,Blt1_AliceA1))
	.db	HIGH(BL(0,Blt1_AliceA2))

St1_EnAliceB:
	lda	#1
	sta	EVS_SEM

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

.away:
	; ҂
	lda	#20
	jsr	Enemy_CB_Wait

	; ޏ
	lda	#$10
	sta	EN_A,x
	tay
	lda	#21
	sta	EN_SP,x
	jmp	Enemy_SetVelocity
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$45,$00,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$0080		; BOSS_LIFE

St1_EnAliceC:
	tay
	jsr	Enemy_SetPosition

	lda	#1
	sta	EVS_SEM

	lda	#5
	sta	EVS_SPELL

	; o

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	lda	#LOW(.retry1)
	sta	EN_CB,x
	lda	#HIGH(.retry1)
	sta	EN_CB+1,x
.retry1:
	lda	#64
	ldy	#48
	jsr	Enemy_CB_Move

	lda	#$5e
	sta	EN_S,x

	lda	#8
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	jsr	Enemy_ClearCallback
	lda	#0
	sta	EVS_SEM

	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS|EPF_REFLECT
	.db	$45,$4a,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$0080		; BOSS_LIFE
	.dw	Enemy_Alice_Reflect

St1_EnAliceD:
	lda	#1
	sta	EVS_SEM

	; ʏUP

	lda	#6
	sta	EVS_A

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam
	lda	#35
	sta	<EN_TIME

	lda	#8
	jsr	Enemy_CB_Wait
.loop:
	; Cl`
	stx	<FNC_WORK+8
	ldy	#$00
	lda	#EN_ST1_SHANGHI_A
	jsr	Enemy_Normal_Create
	ldy	#$80
	lda	#EN_ST1_SHANGHI_A
	jsr	Enemy_Normal_Create
	ldx	<FNC_WORK+8

	lda	EN_S,x
	and	#$c1
	ora	#$02
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	eor	#$06
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	and	#$c1
	sta	EN_S,x

	lda	#24
	jsr	Enemy_CB_Wait

	; ړ
	jsr	St1_EnAlice_SelectPos
	lda	#LOW(.retry2)
	sta	EN_CB,x
	lda	#HIGH(.retry2)
	sta	EN_CB+1,x
.retry2:
	lda	EVS_X
	ldy	EVS_Y
	jsr	Enemy_CB_Move

	; Œe
	lda	#10
	jsr	Enemy_CB_Wait

	lda	#LOW(BL(0,Blt1_AliceC))
	ldy	#HIGH(BL(0,Blt1_AliceC))
	jsr	SMCL(Shot_Normal_Create)

	lda	EN_S,x
	and	#$c1
	ora	#$1e
	sta	EN_S,x
	lda	#08
	jsr	Enemy_CB_Wait
	lda	EN_S,x
	and	#$c1
	sta	EN_S,x
	lda	#42
	jsr	Enemy_CB_Wait

	; ړ
	jsr	St1_EnAlice_SelectPos
	lda	#LOW(.retry4)
	sta	EN_CB,x
	lda	#HIGH(.retry4)
	sta	EN_CB+1,x
.retry4:
	lda	EVS_X
	ldy	EVS_Y
	jsr	Enemy_CB_Move

	; Œe
	lda	#10
	jsr	Enemy_CB_Wait

	lda	#LOW(BL(0,Blt1_AliceC))
	ldy	#HIGH(BL(0,Blt1_AliceC))
	jsr	SMCL(Shot_Normal_Create)

	lda	EN_S,x
	and	#$c1
	ora	#$1e
	sta	EN_S,x
	lda	#08
	jsr	Enemy_CB_Wait
	lda	EN_S,x
	and	#$c1
	sta	EN_S,x
	lda	#42
	jsr	Enemy_CB_Wait

	; ^CAbv{[v
	dec	EVS_A
	beq	.next10
	jmp	.loop
.next10:
	; 

	lda	#2
	jsr	Enemy_CB_Wait

	lda	#0
	sta	<EN_BOSS_LIFE_L
	sta	<EN_BOSS_LIFE_H
	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$45,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$0080		; BOSS_LIFE

St1_EnAliceE:
	lda	#1
	sta	EVS_SEM

	; u̕l`v

	lda	#0
	sta	EVS_A
	lda	#1
	sta	EVS_B

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam
	lda	#39
	sta	<EN_TIME

	; ړ

	lda	#LOW(.retry1)
	sta	EN_CB,x
	lda	#HIGH(.retry1)
	sta	EN_CB+1,x
.retry1:
	lda	#64
	ldy	#48
	jsr	Enemy_CB_Move

	lda	#$5e
	sta	EN_S,x

	lda	#8
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_S,x

	; Hl`
	lda	#$02
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	lda	#$04
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	stx	<FNC_WORK+8
	ldy	#$00
	lda	#EN_ST1_HOURAI_A
	jsr	Enemy_Normal_Create
	ldy	#$01
	lda	#EN_ST1_HOURAI_A
	jsr	Enemy_Normal_Create
	ldy	#$02
	lda	#EN_ST1_HOURAI_A
	jsr	Enemy_Normal_Create
	ldx	<FNC_WORK+8

	lda	#10
	jsr	Enemy_CB_Wait

	lda	#$00
	sta	EN_S,x

	lda	#20
	jsr	Enemy_CB_Wait

.loop1:
	lda	#LOW(BL(0,Blt1_AliceD1))
	ldy	#HIGH(BL(0,Blt1_AliceD1))
	jsr	SMCL(Shot_Normal_Create)

	; ړ
	jsr	St1_EnAlice_SelectPos
	lda	#LOW(.retry2)
	sta	EN_CB,x
	lda	#HIGH(.retry2)
	sta	EN_CB+1,x
.retry2:
	lda	EVS_X
	ldy	EVS_Y
	jsr	Enemy_CB_Move

	lda	#$00
	sta	EN_S,x

	lda	#16
	jsr	Enemy_CB_Wait

	; ړ
	lda	EN_X,x
	asl	a
	asl	a
	lda	#$05
	rol	a
	sta	EN_S,x

	lda	#LOW(.retry3)
	sta	EN_CB,x
	lda	#HIGH(.retry3)
	sta	EN_CB+1,x
.retry3:
	lda	#64
	ldy	#48
	jsr	Enemy_CB_Move

	lda	#$00
	sta	EN_S,x

	lda	#48
	jsr	Enemy_CB_Wait

	; ^CAbv{[v
	inc	EVS_A
	lda	EVS_A
	cmp	#12
	bcs	.next10
	jmp	.loop1
.next10:
	; 
	lda	#2
	jsr	Enemy_CB_Wait

	lda	#0
	sta	EVS_B

	lda	#0
	sta	<EN_BOSS_LIFE_L
	sta	<EN_BOSS_LIFE_H
	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$45,$40,$7f,(ITEM_L_POWER<<4)+7	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$00c0		; BOSS_LIFE

St1_EnAliceF:
	lda	#1
	sta	EVS_SEM

	; ʏUQ

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	.if	OPT_ST1_ALICE_F_HARD
	lda	#20
	.else
	lda	#21
	.endif
	sta	<EN_TIME
	lda	#$ff
	sta	EVS_B
	lda	#6
	sta	EVS_C

	lda	#$40
	sta	EN_S,x

	lda	#20
	jsr	Enemy_CB_Wait
.loop1:
	lda	#$00
	sta	EN_S,x

	lda	#10
	jsr	Enemy_CB_Wait

	; e
	inc	EVS_B
	ldy	EVS_B
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	#$02
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	lda	#$04
	sta	EN_S,x

	ldy	EVS_B
	lda	.wait,y
	jsr	Enemy_CB_Wait

	; ړ
	lda	EVS_B
	lsr	a
	bcc	.skip2
	jsr	St1_EnAlice_SelectPos

	lda	#LOW(.retry2)
	sta	EN_CB,x
	lda	#HIGH(.retry2)
	sta	EN_CB+1,x
.retry2:
	lda	EVS_X
	ldy	EVS_Y
	jsr	Enemy_CB_Move
.skip2:

	dec	EVS_C
	bne	.loop1

	; 
	lda	#2
	jsr	Enemy_CB_Wait

	lda	#0
	sta	<EN_BOSS_LIFE_L
	sta	<EN_BOSS_LIFE_H
	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$45,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$00c0		; BOSS_LIFE
	.if	OPT_ST1_ALICE_F_HARD
.wait:
	.db	86,66,106,86,86,66
.blt_lo:
	.db	LOW(BL(0,Blt1_AliceE1))
	.db	LOW(BL(0,Blt1_AliceE1))
	.db	LOW(BL(0,Blt1_AliceE2))
	.db	LOW(BL(0,Blt1_AliceE2))
	.db	LOW(BL(0,Blt1_AliceE3))
	.db	LOW(BL(0,Blt1_AliceE3))
.blt_hi:
	.db	HIGH(BL(0,Blt1_AliceE1))
	.db	HIGH(BL(0,Blt1_AliceE1))
	.db	HIGH(BL(0,Blt1_AliceE2))
	.db	HIGH(BL(0,Blt1_AliceE2))
	.db	HIGH(BL(0,Blt1_AliceE3))
	.db	HIGH(BL(0,Blt1_AliceE3))
	.else	; OPT_ST1_ALICE_F_HARD
.wait:
	.db	86,66,106,66,86,86
.blt_lo:
	.db	LOW(BL(0,Blt1_AliceE1))
	.db	LOW(BL(0,Blt1_AliceE1))
	.db	LOW(BL(0,Blt1_AliceE2))
	.db	LOW(BL(0,Blt1_AliceE1))
	.db	LOW(BL(0,Blt1_AliceE1))
	.db	LOW(BL(0,Blt1_AliceE2))
.blt_hi:
	.db	HIGH(BL(0,Blt1_AliceE1))
	.db	HIGH(BL(0,Blt1_AliceE1))
	.db	HIGH(BL(0,Blt1_AliceE2))
	.db	HIGH(BL(0,Blt1_AliceE1))
	.db	HIGH(BL(0,Blt1_AliceE1))
	.db	HIGH(BL(0,Blt1_AliceE2))
	.endif	; OPT_ST1_ALICE_F_HARD

St1_EnAliceG:
	lda	#1
	sta	EVS_SEM

	; fuʌ̏Cl`v

	lda	#16
	sta	EVS_A

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam
	lda	#38
	sta	<EN_TIME

	lda	#$00
	sta	EN_ST1_CMD
	sta	EN_ST1_CMD+1
	sta	EN_ST1_PHASE
	lda	#$ff
	sta	EN_ST1_X
	sta	EN_ST1_X+1
	sta	EN_ST1_X+2
	sta	EN_ST1_X+3
	sta	EN_ST1_X+4
	sta	EN_ST1_X+5

	; ړ

	lda	#LOW(.retry1)
	sta	EN_CB,x
	lda	#HIGH(.retry1)
	sta	EN_CB+1,x
.retry1:
	lda	#64
	ldy	#48
	jsr	Enemy_CB_Move

	; Cl`
	stx	<FNC_WORK+8
	ldy	#$00
	lda	#EN_ST1_SHANGHI_B
	jsr	Enemy_Normal_Create
	ldy	#$01
	lda	#EN_ST1_SHANGHI_B
	jsr	Enemy_Normal_Create
	ldy	#$02
	lda	#EN_ST1_SHANGHI_B
	jsr	Enemy_Normal_Create
	ldx	<FNC_WORK+8

	lda	#16
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	eor	#$02
	sta	EN_S,x

	lda	#4
	jsr	Enemy_CB_Wait

	lda	EN_S,x
	eor	#$46
	sta	EN_S,x

	lda	#10
	jsr	Enemy_CB_Wait

	stx	<FNC_WORK
	lda	#BANK_CHR_SPELL
	sta	BGS_BANK3
	lda	#PS_BG_EFFECT_AS
	sta	BGS_PAL3
	lda	#$55
	sta	BGS_ATTR3
	lda	#$02
	sta	BGS_CNT3
	lda	#LOW(St1_BgDrawAliceA)
	ldy	#HIGH(St1_BgDrawAliceA)
	ldx	#(BGS_CNT3-BGS_CNT3)
	jsr	BGSeq_SetLayerCB
	ldx	#RLF_SET_LAYER3
	jsr	BGSeq_ReqSetHighLayer
	ldx	<FNC_WORK

.loop1:
	; e
	lda	#$a8
	sta	EN_ST1_CMD+1
	lda	#2
	jsr	Enemy_CB_Wait
	lda	#$a8
	sta	EN_ST1_CMD+1
	lda	#2
	jsr	Enemy_CB_Wait
	lda	#$a8
	sta	EN_ST1_CMD+1

	lda	#24
	jsr	Enemy_CB_Wait

	; Ԟe
	lda	#$fc
	sta	EN_ST1_CMD+1
	lda	#2
	jsr	Enemy_CB_Wait
	lda	#$fc
	sta	EN_ST1_CMD+1
	lda	#2
	jsr	Enemy_CB_Wait
	lda	#$fc
	sta	EN_ST1_CMD+1

	lda	#24
	jsr	Enemy_CB_Wait

	; ^e
	lda	EVS_A
	and	#$01
	bne	.shot1a
	ldy	#0
	jsr	.ballet
	ldy	#2
	jsr	.ballet
	ldy	#4
	jsr	.ballet
	jmp	.shot1b
.shot1a:
	ldy	#1
	jsr	.ballet
	ldy	#3
	jsr	.ballet
	ldy	#5
	jsr	.ballet
.shot1b:

	lda	#12
	jsr	Enemy_CB_Wait

	; gUe
	lda	EVS_A
	and	#$03
	tay
	lda	.blt_blue_h,y
	sta	<FNC_WORK
	lda	.blt_blue_l,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)

	lda	#6
	jsr	Enemy_CB_Wait

	; ^CAbv{[v
	dec	EVS_A
	beq	.next10
	jmp	.loop1
.next10:
	; 
	lda	#2
	jsr	Enemy_CB_Wait

	lda	#0
	sta	<EN_BOSS_LIFE_L
	sta	<EN_BOSS_LIFE_H
	rts
.ballet:
	lda	EN_X,x
	sta	EN_ST1_X,y
	lda	EN_Y,x
	sta	EN_ST1_Y,y
	lda	#0
	sta	EN_ST1_U,y
	sta	EN_ST1_V,y
	lda	#$f8
	sta	EN_ST1_COUNT,y
	lda	.blt_angle,y
	sta	EN_ST1_A,y
	sta	<FNC_WORK
	lda	#$28
	sta	EN_ST1_SP,y

	sty	<FNC_WORK+3
	ldy	<FNC_WORK
	jsr	Util_GetRadius
	ldy	<FNC_WORK+3
	lda	<FNC_ARG
	sta	EN_ST1_DX,y
	lda	<FNC_ARG+1
	sta	EN_ST1_DY,y
	lda	<FNC_ARG+2
	sta	EN_ST1_DU,y
	lda	<FNC_ARG+3
	sta	EN_ST1_DV,y

	stx	<FNC_WORK
	lda	#$ff
	sta	EN_ST1_INX,y
	jsr	SMCL(Shot_Alloc)
	bvs	.blt9
	txa
	sta	EN_ST1_INX,y
	lda	#$04
	sta	SH_T,x
	lda	EN_ST1_X,y
	sta	SH_X,x
	lda	EN_ST1_Y,y
	sta	SH_Y,x
	tya
	sta	SH_D,x
.blt9:
	ldx	<FNC_WORK

	rts
.param:
	.db	EPF_BASE|EPF_ACC|EPF_BOSS
	.db	$45,$40,$7f,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$00,$00,$00	; VC,IS,IA
	.db	$00		; BOSS_INX
	.dw	$00c0		; BOSS_LIFE
.blt_angle:
	.db	$90,$70,$e5,$c5,$3b,$1b
.blt_blue_l:
	.db	LOW(BL(0,Blt1_AliceH1))
	.db	LOW(BL(0,Blt1_AliceH2))
	.db	LOW(BL(0,Blt1_AliceH1))
	.db	LOW(BL(0,Blt1_AliceH3))
.blt_blue_h:
	.db	HIGH(BL(0,Blt1_AliceH1))
	.db	HIGH(BL(0,Blt1_AliceH2))
	.db	HIGH(BL(0,Blt1_AliceH1))
	.db	HIGH(BL(0,Blt1_AliceH3))

St1_EnAlice_SelectPos:
	jsr	Rand
	and	#$03

	ldy	EN_X,x
	cpy	#60
	bcs	.1
	ora	#$01
.1:
	cpy	#68
	bcc	.2
	and	#$02
.2:

	ldy	EN_Y,x
	cpy	#44
	bcs	.3
	ora	#$02
.3:
	cpy	#56
	bcc	.4
	and	#$01
.4:
	tay
	and	#$01
	eor	#$0b
	sta	EN_S,x

	lda	EN_X,x
	clc
	adc	.xpos,y
	sta	EVS_X
	lda	EN_Y,x
	clc
	adc	.ypos,y
	sta	EVS_Y
	rts
.xpos:
	.db	-24, 24,-24, 24
.ypos:
	.db	-12,-12, 12, 12

St1_EnShanghiA:
	sta	<FNC_WORK+6

	ldy	EN_BOSS_INX
	lda	EN_X,y
	sta	EN_X,x
	lda	EN_Y,y
	sta	EN_Y,x
	lda	#$00
	sta	EN_U,x
	sta	EN_V,x

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	ldy	#$48	; angle
	lda	<FNC_WORK+6
	bpl	.1
	ldy	#$b8	; angle
.1:
	lda	#$08	; speed
	jsr	Enemy_SetVelocity

	ldy	<FNC_WORK+6
	cpy	#$80

	lda	EN_S,x
	bcc	.2
	ora	#$01
.2:
	sta	EN_S,x

	lda	#$88
	bcc	.3
	lda	#$78
.3:
	sta	EN_D,x

	lda	#10
	bcc	.4
	lda	#20
.4:
	jsr	Enemy_CB_Wait

	; Œe
	jsr	Rand
	and	#$03
	ora	EN_D,x
	sta	EN_A,x
	lda	#LOW(BL(0,Blt1_ShanghiA))
	ldy	#HIGH(BL(0,Blt1_ShanghiA))
	jsr	SMCL(Shot_Normal_Create)

	lda	#20
	jsr	Enemy_CB_Wait

	; Œe
	jsr	Rand
	and	#$03
	ora	EN_D,x
	sta	EN_A,x
	lda	#LOW(BL(0,Blt1_ShanghiA))
	ldy	#HIGH(BL(0,Blt1_ShanghiA))
	jsr	SMCL(Shot_Normal_Create)

	rts
.param:
	.db	EPF_BASE
	.db	$03,$42,$08,(ITEM_NONE<<4)+0	; T,S,LIFE,P

St1_EnShanghiB:
	sta	<FNC_WORK+6

	ldy	EN_BOSS_INX
	tya
	sta	EN_D,x
	lda	EN_X,y
	sta	EN_X,x
	lda	EN_Y,y
	sta	EN_Y,x
	lda	#$00
	sta	EN_U,x
	sta	EN_V,x

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

	ldy	<FNC_WORK+6
	lda	EN_T,x
	ora	Xcn,y
	sta	EN_T,x
	lda	.angle,y
	sta	EN_A,x
;	lda	#$78
;	lda	#$d8
	lda	#$00
	sta	EN_SP,x

	lda	#$04
	sta	EN_DY,x
	lda	#$00
	sta	EN_DX,x
.loop1:
	lda	#1
	jsr	Enemy_CB_Wait

	dec	EN_DY,x
	bne	.2
	lda	#$04
	sta	EN_DY,x

	ldy	EN_DX,x
	lda	.atbl,y
	sta	EN_IA,x
	lda	.dtbl,y
	sta	EN_IS,x
	iny
	cpy	#(.dtbl-.atbl)
	bcc	.1
	ldy	#(.atbl1-.atbl)
.1:
	tya
	sta	EN_DX,x
.2:
	lda	EN_T,x
	and	#$f0
	sta	<FNC_WORK+9
	tay
	lda	EN_A,x
	sta	<FNC_WORK+8

	asl	EN_ST1_CMD
	bcc	.7

	lda	EN_ST1_TRACK+2,y
	sta	<FNC_ARG
	lda	EN_ST1_TRACK+3,y
	sta	<FNC_ARG+1
	lda	EN_X,x
	sta	<FNC_ARG+2
	ldy	EN_Y,x
	sty	<FNC_ARG+3
	cmp	<FNC_ARG
	beq	.3
	cpy	<FNC_ARG+1
	beq	.3
	jsr	Util_GetAngle
	sta	EN_A,x
.3:

	asl	EN_ST1_CMD
	bcs	.5
	lda	#LOW(BL(0,Blt1_ShanghiB1))
	ldy	#HIGH(BL(0,Blt1_ShanghiB1))
	jmp	.6
.5:
	lda	#LOW(BL(0,Blt1_ShanghiB2))
	ldy	#HIGH(BL(0,Blt1_ShanghiB2))
.6:
	jsr	SMCL(Shot_Normal_Create)
.7:
	lda	<FNC_WORK+8
	sta	EN_A,x

	ldy	<FNC_WORK+9
	lda	EN_ST1_TRACK+1,y
	sta	EN_ST1_TRACK+3,y
	lda	EN_ST1_TRACK,y
	sta	EN_ST1_TRACK+2,y
	lda	EN_Y,x
	sta	EN_ST1_TRACK+1,y
	lda	EN_X,x
	sta	EN_ST1_TRACK,y

	jmp	.loop1

	rts
.param:
	.db	EPF_BASE|EPF_ACC
	.db	$06,$44,$08,(ITEM_NONE<<4)+0	; T,S,LIFE,P
	.db	$01,$00,$00	; VC,IS,IA
.angle:
	.db	$00,$55,$ab
; $00->$c0->$50->
; $60->$20->$60->$20->
; $30->$f0->$30->$f0->
.atbl:
	.db	$01,$02,$03,$03,$04,$04,$05,$05
	.db	$04,$04,$03,$03,$02,$01,$00,$ff
	.db	$fe,$fd,$fd,$fd,$fd,$fd,$fd,$fe
	.db	$ff,$00
.atbl1:
	.db	$01,$02,$02,$01,$00,$ff,$fe,$fd
	.db	$fd,$fd,$fd,$fe,$ff,$00,$01,$02
	.db	$03,$03,$03,$03,$02,$01,$00,$ff
	.db	$fe,$fd,$fd,$fd,$fd,$fe,$ff,$00
.dtbl:
	.db	$13,$0f,$0b,$06,$03,$00,$00,$00
	.db	$00,$00,$00,$00,$fe,$fa,$f8,$fa
	.db	$fe,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00
.dtbl1:
	.db	$00,$00,$02,$06,$08,$06,$02,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00
	.db	$00,$00,$00,$00,$fe,$fa,$f8,$fa
	.db	$fe,$00,$00,$00,$00,$00,$00,$00

St1_EnHouraiA:
	sta	EN_D,x
	tay
	lda	#$00
	sta	EN_U,x
	sta	EN_V,x
	sta	EN_ST1_COUNT,y

	ldy	EN_BOSS_INX
	lda	EN_X,y
	sta	EN_X,x
	lda	EN_Y,y
	sta	EN_Y,x

	lda	#LOW(.param)
	ldy	#HIGH(.param)
	jsr	Enemy_SetParam

.loop1:
	lda	#1
	jsr	Enemy_CB_Wait

	ldy	EN_D,x

	lda	EN_ST1_COUNT,y
	sec
	sbc	#$04
	sta	EN_ST1_COUNT,y

	clc
	adc	.angle,y
	sta	<FNC_WORK
	lda	EN_ST1_COUNT,y
	and	#$78
	lsr	a
	lsr	a
	lsr	a
	tay
	lda	.dist,y
	ldy	<FNC_WORK
	jsr	.setpos

	ldy	EN_D,x

	lda	EN_ST1_COUNT,y
	and	#$7f
	bne	.loop1

	lda	#2
	jsr	Enemy_CB_Wait

.loop2:
	lda	#2
	jsr	Enemy_CB_Wait

	ldy	EN_D,x

	lda	EN_ST1_COUNT,y
	clc
	adc	#$01
	sta	EN_ST1_COUNT,y

	clc
	adc	.angle,y
	tay
	lda	#96
	jsr	.setpos

	ldy	EN_D,x

	lda	EN_ST1_COUNT,y
	and	#$7f
	cmp	#$04
	bcc	.loop2

.loop3:
	lda	#1
	jsr	Enemy_CB_Wait

	ldy	EN_D,x

	lda	EN_ST1_COUNT,y
	clc
	adc	#$02
	sta	EN_ST1_COUNT,y

	clc
	adc	.angle,y
	tay
	lda	#96
	jsr	.setpos

	ldy	EN_D,x

	lda	EVS_B
	bne	.loop3

	; 
	sec
	ror	EN_X,x

	rts
.setpos:
	jsr	Util_GetRadius
	ldy	EN_BOSS_INX
	lda	EN_X,y
	clc
	adc	<FNC_ARG
	sta	EN_X,x
	lda	EN_Y,y
	clc
	adc	<FNC_ARG+1
	sta	EN_Y,x

	lda	EN_S,y
	and	#$1e
	cmp	#$0a
	bne	.10
	lda	EN_S,y
	eor	EN_S,x
	eor	#$01
	and	#$03
	eor	EN_S,x
	bne	.11	; same as jmp
.10:
	lda	#$40
.11:
	sta	EN_S,x
	rts
.param:
	.db	EPF_BASE
	.db	$04,$40,$08,(ITEM_NONE<<4)+0	; T,S,LIFE,P
.dist:
	.db	 96,106,114,120,124,126,124,120
	.db	114,106, 96, 84, 70, 54, 36, 16
.angle:
	.db	$00,$55,$ab

; eۊ֌W

St1_ShCbAliceA:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$0f
	tay
	lda	SH_X,x
	clc
	adc	.xpos,y
	sta	SH_X,x

	ldy	EVS_B
	lda	.color,y
	sta	SH_B,x

	tya
	lsr	a
	lda	#$08
	bcc	.1
	lda	#$f8
.1:
	sta	SH_IA,x
	lda	#$03
	sta	SH_VC,x
	sta	SH_VN,x

	lda	#$0e
	sta	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity

	lda	#$00
	sta	SH_C,x
	sta	SH_D,x

	lda	#LOW(St1_ShCbAliceA2)
	sta	SH_CB,x
	lda	#HIGH(St1_ShCbAliceA2)
	sta	SH_CB+1,x
	lda	#3
	sta	SH_FC,x

	rts
.xpos:
	.db	-34,34,-34,34,-34,34
.color:
	.db	COL_RED,   COL_BLUE
	.db	COL_GREEN, COL_PINK
	.db	COL_RED,   COL_BLUE

St1_ShCbAliceA2:
	ldy	EVS_B
	inc	SH_D,x
	lda	SH_D,x
	cmp	.blt_life,y
	bcc	.1
	ror	SH_X,x
	rts
.1:
	inc	SH_C,x
	lda	SH_C,x
	cmp	#5
	bcc	.3
	lda	#0
	sta	SH_C,x
	lda	EVS_B
	lsr	a
	bcs	.2
	inc	SH_IA,x
	bcc	.3	; same as jmp
.2:
	dec	SH_IA,x
.3:

	lda	SH_A,x
	sta	<FNC_WORK+8
	ldy	EVS_B
	cpy	#2
	bcc	.4
	jsr	Rand
	and	#$0f
	sec
	sbc	#$08
	clc
	adc	SH_A,x
	sta	SH_A,x
.4:
	lda	#LOW(St1_ShCbAliceA2)
	sta	SH_CB,x
	lda	#HIGH(St1_ShCbAliceA2)
	sta	SH_CB+1,x
	lda	.blt_int,y
	sta	SH_FC,x
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jsr	SMCL(Shot_Normal_Create)
	lda	<FNC_WORK+8
	sta	SH_A,x
	rts
.blt_life:
	.db	12,12,12,12
.blt_int:
	.db	4,4,4,4
.blt_lo:
	.db	LOW(BL(0,Blt1_AliceB1))
	.db	LOW(BL(0,Blt1_AliceB2))
	.db	LOW(BL(0,Blt1_AliceB3))
	.db	LOW(BL(0,Blt1_AliceB4))
.blt_hi:
	.db	HIGH(BL(0,Blt1_AliceB1))
	.db	HIGH(BL(0,Blt1_AliceB2))
	.db	HIGH(BL(0,Blt1_AliceB3))
	.db	HIGH(BL(0,Blt1_AliceB4))

St1_ShCbAliceB1:
	lda	#$02
	sta	SH_IS,x

	lda	#LOW(St1_ShCbAliceB2)
	sta	SH_CB,x
	lda	#HIGH(St1_ShCbAliceB2)
	sta	SH_CB+1,x
	lda	#$34
	sta	SH_FC,x

	rts

St1_ShCbAliceB2:
	lda	#$00
	sta	SH_IS,x
	rts

St1_ShCbAliceC:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$03
	tay

	lda	SH_A,x
	eor	#$80
	sta	SH_A,x
	lda	#$00
	sta	SH_IS,x
	lda	#$01
	sta	SH_IA,x
	lda	#$03
	sta	SH_VC,x
	sta	SH_VN,x
	lda	.speed,y
	sta	SH_SP,x

	lda	SH_A,x
	clc
	adc	#$30
	cmp	#$60
	bcs	.1

	lda	#LOW(St1_ShCbAliceC2)
	sta	SH_CB,x
	lda	#HIGH(St1_ShCbAliceC2)
	sta	SH_CB+1,x
	lda	#$02
	sta	SH_FC,x
.1:

	ldy	#SE_EN_SHOT3
	cpy	<SND_SE
	bcc	.2
	sty	<SND_SE
.2:
	rts
.speed:
	.db	$10, $0d, $0a

St1_ShCbAliceC2:
	ldy	EN_BOSS_INX
	lda	SH_Y,x
	sec
	sbc	EN_Y,y
	bcc	.1
	lda	#$02
	sta	SH_FC,x
	rts
.1:
	eor	#$ff
;	sec
	adc	EN_Y,y
	sta	SH_Y,x

	lda	#$8f
	sec
	sbc	SH_A,x
	sta	SH_A,x
	lda	#$ff
	sta	SH_IA,x

	lda	SH_SP,x
	ldy	SH_A,x
	jmp	Shot_SetVelocity

St1_ShCbAliceD1:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$03
	tay
	lda	EN_ST1_COUNT,y
	clc
	adc	.angle,y
	clc
	adc	#$2b
	sta	<FNC_WORK+3
	tay
	lda	#96
	jsr	Util_GetRadius
	ldy	EN_BOSS_INX
	lda	EN_X,y
	clc
	adc	<FNC_ARG
	sta	SH_X,x
	lda	EN_Y,y
	clc
	adc	<FNC_ARG+1
	sta	SH_Y,x

	lda	#LOW(St1_ShCbAliceD2)
	sta	SH_CB,x
	lda	#HIGH(St1_ShCbAliceD2)
	sta	SH_CB+1,x
	lda	#$10
	sta	SH_FC,x

	lda	EVS_A
	lsr	a
	lda	<FNC_WORK+3
	bcs	.1
;	clc
	adc	#$c0
.1:
	sta	SH_A,x
	tay
	lda	SH_SP,x
	jsr	Shot_SetVelocity
	lda	SH_A,x
	ldy	SH_D,x
	jmp	Shot_Normal_SetObjData
.angle:
	.db	$00,$55,$ab

St1_ShCbAliceD2:
	ldy	#SE_EN_SHOT3
	cpy	<SND_SE
	bcc	.1
	sty	<SND_SE
.1:
	stx	<FNC_WORK+8
	lda	#LOW(BL(0,Blt1_AliceD2))
	ldy	#HIGH(BL(0,Blt1_AliceD2))
	jsr	SMCL(Shot_Normal_Create)

	lda	<FNC_WORK+8
	sec
	ror	SH_X,x
	rts

St1_ShCbAliceD3:
	ldy	#SE_EN_SHOT3
	cpy	<SND_SE
	bcc	.1
	sty	<SND_SE
.1:
	jsr	Rand
	and	#$07
	tay
	lda	SH_A,x
	clc
	adc	Int+$fc,y
	sta	SH_A,x

	stx	<FNC_WORK+8
	lda	#LOW(BL(0,Blt1_AliceD3))
	ldy	#HIGH(BL(0,Blt1_AliceD3))
	jsr	SMCL(Shot_Normal_Create)

	lda	<FNC_WORK+8
	sec
	ror	SH_X,x
	rts

St1_ShCbAliceE:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$0f
	tay
	lda	SH_X,x
	clc
	adc	.xpos,y
	sta	SH_X,x
	lda	SH_Y,x
	clc
	adc	.ypos,y
	sta	SH_Y,x

	ldy	EVS_B
	lda	.color,y
	sta	SH_B,x

	tya
	lsr	a
	lda	SH_A,x
	ldy	#$fa
	bcc	.1
	eor	#$80
	ldy	#$06
.1:
	clc
	adc	#$c0
	sta	SH_A,x

	tya
	sta	SH_IA,x
	lda	#$03
	sta	SH_VC,x
	sta	SH_VN,x

	lda	#$0a
	sta	SH_SP,x
	ldy	SH_A,x
	jsr	Shot_SetVelocity

	lda	#$00
	sta	SH_C,x
	sta	SH_D,x

	lda	#LOW(St1_ShCbAliceE2)
	sta	SH_CB,x
	lda	#HIGH(St1_ShCbAliceE2)
	sta	SH_CB+1,x
	lda	#3
	sta	SH_FC,x

	rts
.xpos:
	.db	  0, 0,-34,34,-29, 29
.ypos:
	.db	-34,34,  0, 0,-17,-17
.color:
	.db	COL_BLUE,  COL_RED
	.db	COL_GREEN, COL_YELLOW
	.db	COL_BLUE,  COL_RED

St1_ShCbAliceE2:
	ldy	EVS_B
	inc	SH_D,x
	lda	SH_D,x
	cmp	.blt_life,y
	bcs	.9

	inc	SH_C,x
	lda	SH_C,x
	cmp	#11
	bcc	.2
	lda	#0
	sta	SH_C,x
	lda	EVS_B
	lsr	a
	bcs	.1
	dec	SH_IA,x
	bcc	.2	; same as jmp
.1:
	inc	SH_IA,x
.2:

	lda	EVS_B
	asl	a
	tay
	lda	SH_A,x
	sec
	sbc	#$40
	cmp	#$80
	bcs	.3
	iny
.3:
	lda	#LOW(St1_ShCbAliceE2)
	sta	SH_CB,x
	lda	#HIGH(St1_ShCbAliceE2)
	sta	SH_CB+1,x
	lda	.blt_int,y
	sta	SH_FC,x
	lda	.blt_hi,y
	sta	<FNC_WORK
	lda	.blt_lo,y
	ldy	<FNC_WORK
	jmp	SMCL(Shot_Normal_Create)
.9:
	ror	SH_X,x
	rts
.blt_life:
	.db	36,36,36,36,24,24
.blt_int:
	.db	3,3,3,3,4,4,4,4,5,5,5,5
.blt_lo:
	.db	LOW(BL(0,Blt1_AliceF1))
	.db	LOW(BL(0,Blt1_AliceF2))
	.db	LOW(BL(0,Blt1_AliceF3))
	.db	LOW(BL(0,Blt1_AliceF4))
	.db	LOW(BL(0,Blt1_AliceF5))
	.db	LOW(BL(0,Blt1_AliceF6))
	.db	LOW(BL(0,Blt1_AliceF7))
	.db	LOW(BL(0,Blt1_AliceF8))
	.db	LOW(BL(0,Blt1_AliceF9))
	.db	LOW(BL(0,Blt1_AliceF10))
	.db	LOW(BL(0,Blt1_AliceF11))
	.db	LOW(BL(0,Blt1_AliceF12))
.blt_hi:
	.db	HIGH(BL(0,Blt1_AliceF1))
	.db	HIGH(BL(0,Blt1_AliceF2))
	.db	HIGH(BL(0,Blt1_AliceF3))
	.db	HIGH(BL(0,Blt1_AliceF4))
	.db	HIGH(BL(0,Blt1_AliceF5))
	.db	HIGH(BL(0,Blt1_AliceF6))
	.db	HIGH(BL(0,Blt1_AliceF7))
	.db	HIGH(BL(0,Blt1_AliceF8))
	.db	HIGH(BL(0,Blt1_AliceF9))
	.db	HIGH(BL(0,Blt1_AliceF10))
	.db	HIGH(BL(0,Blt1_AliceF11))
	.db	HIGH(BL(0,Blt1_AliceF12))

St1_ShCbAliceG1:
	lda	#LOW(St1_ShCbAliceG2)
	sta	SH_CB,x
	lda	#HIGH(St1_ShCbAliceG2)
	sta	SH_CB+1,x
	lda	#$0c
	sta	SH_FC,x

	lda	SH_T,x
	tay
	and	#$1f
	sta	SH_T,x

	lda	Xcn,y
	and	#$0f
	sta	SH_D,x
	rts

St1_ShCbAliceG2:
	lda	#$06
	sta	SH_VC,x
	sta	SH_VN,x
	lda	#$02
	sta	SH_IS,x

	ldy	SH_T,x
	lda	Xcn,y
	and	#$01
	tay

	lda	SH_A,x
	clc
	adc	.angle,y
	sta	SH_A,x

	ldy	SH_A,x
	lda	SH_SP,x
	jmp	Shot_SetVelocity
.angle:
	.db	$95, $6b

St1_ShCbShanghiA:
	lda	#$00
	sta	SH_VC,x
	sta	SH_VN,x
	sta	SH_IS,x
	rts

St1_ShCbShanghiB1:
	lda	#LOW(St1_ShCbShanghiB2)
	sta	SH_CB,x
	lda	#HIGH(St1_ShCbShanghiB2)
	sta	SH_CB+1,x
	lda	#$18
	sta	SH_FC,x

	ldy	SH_T,x
	lda	Xcn,y
	and	#$01
	tay

	lda	SH_A,x
	clc
	adc	.angle,y
	sta	SH_A,x
	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	ldy	SH_A,x
	lda	SH_SP,x
	clc
	adc	#$02
	sta	SH_SP,x
	jmp	Shot_SetVelocity
.angle:
	.db	$a0, $60

St1_ShCbShanghiB2:
	ldy	SH_T,x
	lda	Xcn,y
	and	#$01
	tay

	lda	SH_A,x
	clc
	adc	.angle,y
	sta	SH_A,x
	ldy	SH_D,x
	jsr	Shot_Normal_SetObjData

	ldy	SH_A,x
	lda	SH_SP,x
	clc
	adc	#$04
	sta	SH_SP,x
	jmp	Shot_SetVelocity
.angle:
	.db	$a0, $60

